local targeticon = CreateFrame("Button", "TargetActions", TargetFrame)
targeticon:Hide()
targeticon:SetWidth(32)
targeticon:SetHeight(32)
targeticon:SetPoint("TOPLEFT", TargetFrame, "TOPLEFT", 119, 3)
targeticon:SetHighlightTexture("Interface\\Minimap\\UI-Minimap-ZoomButton-Highlight")
local bg = targeticon:CreateTexture("TargetClassBackground", "BACKGROUND")
bg:SetTexture("Interface\\Minimap\\UI-Minimap-Background")
bg:SetWidth(20)
bg:SetHeight(20)
bg:SetPoint("CENTER")
bg:SetVertexColor(0, 0, 0, 0.7)
local icon = targeticon:CreateTexture("TargetClassIcon", "ARTWORK")
icon:SetTexture("Interface\\WorldStateFrame\\Icons-Classes")
icon:SetWidth(20)
icon:SetHeight(20)
icon:SetPoint("CENTER")
local lay = targeticon:CreateTexture("TargetClassBorder", "OVERLAY")
lay:SetTexture("Interface\\Minimap\\MiniMap-TrackingBorder")
lay:SetWidth(54)
lay:SetHeight(54)
lay:SetPoint("CENTER", 11, -12)
RaiseFrameLevel(targeticon)

targeticon:SetScript("OnUpdate", function(self)
	if (not UnitCanAttack("player","target") and UnitIsPlayer("target")) then
		targeticon:Enable()
	--	TargetClassIcon:SetDesaturated(false)
		SetDesaturation(TargetClassIcon, false)
	else
		targeticon:Disable()
	--	TargetClassIcon:SetDesaturated(true)
		SetDesaturation(TargetClassIcon, true)
	end
end)

local havedown = false

local function TargetClassIconDown()
	local point, relativeTo, relativePoint, offsetX, offsetY = TargetClassIcon:GetPoint()
	TargetClassIcon:SetPoint(point, relativeTo, relativePoint, offsetX+1, offsetY-1)
	return true
end

-- targeticon:RegisterForClicks("AnyDown")
targeticon:SetScript("OnMouseDown", function(self, button)
	if (not UnitCanAttack("player","target") and UnitIsPlayer("target")) then
		if button == "RightButton" then
				havedown = TargetClassIconDown()
				InspectUnit("target")
		elseif button == "MiddleButton" then
			if CheckInteractDistance("target",2) then
				havedown = TargetClassIconDown()
				InitiateTrade("target")
			end
		elseif button == "LeftButton" then
			if CheckInteractDistance("target",4) then
				havedown = TargetClassIconDown()
				FollowUnit("target");
			end
		else
			if CheckInteractDistance("target",1) then
				havedown = TargetClassIconDown()
				InspectAchievements("target")
			end
		end
	end
end)

local function TargetClassIconUp()
	local point, relativeTo, relativePoint, offsetX, offsetY = TargetClassIcon:GetPoint()
	TargetClassIcon:SetPoint(point, relativeTo, relativePoint, offsetX-1, offsetY+1)
	return false
end

-- targeticon:RegisterForClicks("AnyUp")
targeticon:SetScript("OnMouseUp", function(self)
	if havedown then
		havedown = TargetClassIconUp()
	end
end)

hooksecurefunc("TargetFrame_Update", function()
	if UnitIsPlayer("target") then
	--	local _, class = UnitClass("target")
	--	local coord = CLASS_ICON_TCOORDS[class]
	--	TargetClassIcon:SetTexCoord(coord[1], coord[2], coord[3], coord[4])

		local coord = CLASS_ICON_TCOORDS[select(2, UnitClass("target"))]
		TargetClassIcon:SetTexCoord(unpack(coord))
		targeticon:Show()
	else
		targeticon:Hide()
	end
end)
